import 'package:freezed_annotation/freezed_annotation.dart';
import 'package:imi/src/utils/enum.dart';

///
/// Code generated by jsonToDartModel https://ashamp.github.io/jsonToDartModel/
///
class CategoryDocument {
  CategoryDocument({
    this.id,
    this.name,
    this.color,
    this.order,
    this.emoji,
  });

  CategoryDocument.fromJson(dynamic json) {
    id = json['id'];
    name = json['name'];
    color = json['color'];
    order = json['order'];
    emoji = json['emoji'];
  }

  int? id;
  String? name;
  String? color;
  int? order;
  String? emoji;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map['id'] = id;
    map['name'] = name;
    map['color'] = color;
    map['order'] = order;
    map['emoji'] = emoji;
    return map;
  }
}

class DocumentByIdLevels {
/*
{
  "id": 5,
  "name": "Chương trình học level 5",
  "status": "ACTIVE"
}
*/

  int? id;
  String? name;
  String? status;

  DocumentByIdLevels({
    this.id,
    this.name,
    this.status,
  });

  DocumentByIdLevels.fromJson(Map<String, dynamic> json) {
    id = json['id']?.toInt();
    name = json['name']?.toString();
    status = json['status']?.toString();
  }

  Map<String, dynamic> toJson() {
    final data = <String, dynamic>{};
    data['id'] = id;
    data['name'] = name;
    data['status'] = status;
    return data;
  }
}

class FetchDocumentData {
/*
{
  "description": "String",
  "id": 29,
  "imageUrl": "String",
  "isLocked": true,
  "levels": [
    {
      "id": 5,
      "name": "Chương trình học level 5",
      "status": "ACTIVE"
    }
  ],
  "link": "String",
  "modifiedDate": "1651744524811",
  "privacy": "PRIVATE",
  "title": "NĂNG ĐOẠN KIM CƯƠNG CẤP ĐỘ 3",
  "type": "E_BOOK"
}
*/

  String? description;
  int? id;
  String? imageUrl;
  bool? isLocked;
  List<DocumentByIdLevels>? levels;
  List<CategoryDocument>? categories;
  List<LeaderType>? leaderTypes;
  String? link;
  String? modifiedDate;
  String? privacy;
  String? title;
  String? type;

  FetchDocumentData({
    this.description,
    this.id,
    this.imageUrl,
    this.isLocked,
    this.levels,
    this.categories,
    this.leaderTypes,
    this.link,
    this.modifiedDate,
    this.privacy,
    this.title,
    this.type,
  });

  FetchDocumentData.fromJson(Map<String, dynamic> json) {
    description = json['description']?.toString();
    id = json['id']?.toInt();
    imageUrl = json['imageUrl']?.toString();
    isLocked = json['isLocked'];
    if (json['levels'] != null) {
      final v = json['levels'];
      final arr0 = <DocumentByIdLevels>[];
      v.forEach((v) {
        arr0.add(DocumentByIdLevels.fromJson(v));
      });
      levels = arr0;
    }
    if (json['categories'] != null) {
      final v = json['categories'];
      final arr0 = <CategoryDocument>[];
      v.forEach((v) {
        arr0.add(CategoryDocument.fromJson(v));
      });
      categories = arr0;
    }
    //leaderTypes = json['leaderTypes']?.map<String>((e) => e.toString()).toList();
    List<LeaderType?>? rawRoles = json['leaderTypes']
        ?.map<LeaderType?>((e) =>
        LeaderType.values.firstWhereOrNull((element) => element.name == e))
        ?.toList();
    leaderTypes = rawRoles?.whereNotNull().toList() ?? [];
    link = json['link']?.toString();
    modifiedDate = json['modifiedDate']?.toString();
    privacy = json['privacy']?.toString();
    title = json['title']?.toString();
    type = json['type']?.toString();
  }

  Map<String, dynamic> toJson() {
    final data = <String, dynamic>{};
    data['description'] = description;
    data['id'] = id;
    data['imageUrl'] = imageUrl;
    data['isLocked'] = isLocked;
    if (levels != null) {
      final v = levels;
      final arr0 = [];
      v!.forEach((v) {
        arr0.add(v.toJson());
      });
      data['levels'] = arr0;
    }
    if (categories != null) {
      final v = categories;
      final arr0 = [];
      v!.forEach((v) {
        arr0.add(v.toJson());
      });
      data['categories'] = arr0;
    }
    data['leaderTypes'] = leaderTypes?.map((e) => e.name).toList();
    data['link'] = link;
    //data['leaderTypes'] = leaderTypes;
    data['modifiedDate'] = modifiedDate;
    data['privacy'] = privacy;
    data['title'] = title;
    data['type'] = type;
    return data;
  }
}

class DetailLibraryResponse {
/*
{
  "fetchDocumentById": {
    "description": "String",
    "id": 29,
    "imageUrl": "String",
    "isLocked": true,
    "levels": [
      {
        "id": 5,
        "name": "Chương trình học level 5",
        "status": "ACTIVE"
      }
    ],
    "link": "String",
    "modifiedDate": "1651744524811",
    "privacy": "PRIVATE",
    "title": "NĂNG ĐOẠN KIM CƯƠNG CẤP ĐỘ 3",
    "type": "E_BOOK"
  }
}
*/

  FetchDocumentData? fetchDocumentById;

  DetailLibraryResponse({
    this.fetchDocumentById,
  });

  DetailLibraryResponse.fromJson(Map<String, dynamic> json) {
    fetchDocumentById = (json['fetchDocumentById'] != null)
        ? FetchDocumentData.fromJson(json['fetchDocumentById'])
        : null;
  }

  Map<String, dynamic> toJson() {
    final data = <String, dynamic>{};
    if (fetchDocumentById != null) {
      data['fetchDocumentById'] = fetchDocumentById!.toJson();
    }
    return data;
  }
}

class DetailLibrary {
/*
{
  "data": {
    "fetchDocumentById": {
      "description": "String",
      "id": 29,
      "imageUrl": "String",
      "isLocked": true,
      "levels": [
        {
          "id": 5,
          "name": "Chương trình học level 5",
          "status": "ACTIVE"
        }
      ],
      "link": "String",
      "modifiedDate": "1651744524811",
      "privacy": "PRIVATE",
      "title": "NĂNG ĐOẠN KIM CƯƠNG CẤP ĐỘ 3",
      "type": "E_BOOK"
    }
  }
}
*/

  DetailLibraryResponse? data;

  DetailLibrary({
    this.data,
  });

  DetailLibrary.fromJson(Map<String, dynamic> json) {
    data = (json['data'] != null)
        ? DetailLibraryResponse.fromJson(json['data'])
        : null;
  }

  Map<String, dynamic> toJson() {
    final data = <String, dynamic>{};
    if (data != null) {
      data['data'] = this.data!.toJson();
    }
    return data;
  }
}
